<?php
/*
 * Plugin Name: Debug Editor
 * Version: 1.2
 * Description: A developer's must-have debug editor.
 * Plugin URI: https://www.xiaomac.com/debug-editor.html
 * Author: Link
 * Author URI: https://www.xiaomac.com/
 * Text Domain: debug-editor
 * Domain Path: /lang
*/

add_action('admin_init', 'debug_editor_admin_init');
function debug_editor_admin_init(){
    if(!is_admin() || !is_super_admin()) return;
    add_action('all_admin_notices', 'debug_editor_options_page');
    add_action('admin_bar_menu', 'debug_editor_admin_menubar', 99);
    add_action('admin_action_debug-editor', 'debug_editor_admin_action');
    if(false === $debug_editor_code = debug_editor_code_check()) return;
    add_filter('wp_die_handler', 'debug_editor_wp_die');
    add_filter('wp_fatal_error_handler_enabled', 'debug_editor_error_handler');
    ob_start();
}

function debug_editor_admin_action(){
    if(false === $debug_editor_code = debug_editor_code_check()) return;
    ob_clean();
    try{
        $result = eval($debug_editor_code);
        echo $result;
    }catch(\Exception $ex){
        print_r($ex);
    }
    exit();
}

function debug_editor_code_check(){
    if(!isset($_POST['action'], $_POST['debug_editor_code']) || $_POST['action'] != 'debug-editor') return false;
    return str_replace(array("\\'",'\\"',"\\\\"), array("'",'"',"\\"), $_POST['debug_editor_code']);
}

function debug_editor_admin_menubar($wp_admin_bar){
    $link = array('id'=>'debug-editor', 'title'=>__('Debug Editor','debug-editor'), 'href'=>'#debug-editor');
    $wp_admin_bar->add_node($link);
}

function debug_editor_wp_die(){
    if(isset($_POST['action'], $_POST['debug_editor_code']) && $_POST['action'] == 'debug-editor') exit();
}

function debug_editor_error_handler($able){
    if(isset($_POST['action'], $_POST['debug_editor_code']) && $_POST['action'] == 'debug-editor') return false;
    return $able;
}

function debug_editor_options_page(){ ?>
    <style>
        #wp-admin-bar-debug-editor {color: #0073aa}
        #wp-admin-bar-debug-editor.current {background: #0073aa}
        #debug_editor_wrap {padding: 18px 2px 2px; display: none; width: 75%;}
        #debug_editor_code {height: 120px; width: 100%;}
        #debug_editor_out {padding: 8px 13px; background: #fff; display: none; white-space: pre-wrap; word-wrap: break-word;}
        #debug_editor_submit {width: 150px; margin-bottom: 10px;}
        .debug_editor_about {float: right;}
    </style>
    <div id="debug_editor_wrap">
        <textarea id="debug_editor_code" name="debug_editor_code" required></textarea><br/>
        <p class="debug_editor_about">
            <a href="https://www.xiaomac.com/2017122069.html" target="_blank">About Debug Editor</a>
        </p>
        <p><input type="button" id="debug_editor_submit" class="button button-primary" value="RUN THIS CODE"></p>
        <pre id="debug_editor_out" style="white-space: pre-wrap"></pre>
    </div>
    <script type="text/javascript">
    jQuery(function($){
        var code = window.localStorage ? localStorage.getItem('debug_editor_code') : "echo date('Y-m-d H:i:s',time());";
        $('#debug_editor_code').val(code);
        if(window.localStorage && localStorage.getItem('debug_editor_show')*1){
            $('#wp-admin-bar-debug-editor').addClass('current');
            jQuery("#debug_editor_wrap").show();
        }
        $('#wp-admin-bar-debug-editor').click(function(){
            jQuery('html,body').animate({scrollTop: 0});
            jQuery('#debug_editor_wrap').slideToggle('fast', function(){
                if(jQuery(this).is(':visible')){
                    window.localStorage && localStorage.setItem('debug_editor_show', 1);
                    $('#wp-admin-bar-debug-editor').addClass('current');
                }else{
                    window.localStorage && localStorage.setItem('debug_editor_show', 0);
                    $('#wp-admin-bar-debug-editor').removeClass('current');
                }
            });
            return false;
        });
        $('#debug_editor_code').focus(function(){
            $(this).animate({height: 250}, 200);
        });
        $('#debug_editor_submit').click(function(){
            $('#debug_editor_out').slideUp();
            var code = $('#debug_editor_code').val();
            if(!code) return $('#debug_editor_code').focus();
            window.localStorage && localStorage.setItem('debug_editor_code', code);
            var data = {action:'debug-editor', debug_editor_code:code};
            $.post('<?php echo esc_url($_SERVER['SCRIPT_NAME']);?>', data, function(response){
                jQuery('html,body').animate({scrollTop: jQuery('#debug_editor_wrap').position().top});
                $('#debug_editor_out').text(response).slideDown();
            });
            $(this).blur();
        });
    });
    </script>
    <?php
}

?>